/*
 *  cameraCapture.cpp
 *  emptyExample
 *
 *  Created by theo on 17/11/2010.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "cameraCapture.h"

//---------------------------------
cameraCapture::cameraCapture(){
	bCameraRunning = false;
}

//---------------------------------
void cameraCapture::openCamera(){
	preFrame = -1;
	
	printf("threadedFunction starting!\n");
	
	if( cam.setup(0) ){
	
		//ofSleepMillis(4000);
		startThread(true, true);
		bCameraRunning = true;
	}
	
	bCameraRunning = false;
}

//---------------------------------
void cameraCapture::closeCamera(){
	
	if( isThreadRunning() ){
		if( lock() ){
			cam.closeSession();
			cam.destroy();
			unlock();
		}
	}else{
		cam.closeSession();
		cam.destroy();	
	}
	
	bCameraRunning = false;
}

//---------------------------------
bool cameraCapture::isCameraRunning(){
	bCameraRunning = cam.getIsCameraRunning();
	return bCameraRunning;
}

//---------------------------------
bool cameraCapture::isLiveViewActive(){
	
	if( isThreadRunning() ){
		return false;
	}
	
	return (bCameraRunning && cam.getLiveViewActive());
}

//---------------------------------
void cameraCapture::threadedFunction(){

	if( lock() ){

		ofSleepMillis(2000);
		cam.openSession();

		ofSleepMillis(6000);
		cam.beginLiveView();
		printf("threadedFunction ending!\n");
		stopThread();
		
		unlock();
	}
}

//	//focus key - don't foget to release the shutter!
//	if( key == 'f'){
//		cam.sendCommand( kEdsCameraCommand_PressShutterButton, kEdsCameraCommand_ShutterButton_Halfway );
//		cam.sendCommand(kEdsCameraCommand_PressShutterButton, kEdsCameraCommand_ShutterButton_OFF);
//	}

//---------------------------------
bool cameraCapture::isFrameNew(){
	return bFrameNew;
}	

//---------------------------------
void cameraCapture::update(){

//	if( cam.getLiveViewActive() && cam.getLiveViewFrameNo() !=  preFrame ){	
//		preFrame = cam.getLiveViewFrameNo();
//		printf("frame %i\n", preFrame);
//		bFrameNew = true;
//	}else{
//		bFrameNew = false;
//	}
//	
	bFrameNew = false;

	if( cam.getLiveViewActive() && ofGetFrameNum() %4 == 0 ){
		
		#ifdef DO_HORIZONTAL
			cam.grabPixelsFromLiveView(0);
		#else
			cam.grabPixelsFromLiveView(1);
		#endif
	
		if( img.getWidth() == 0 && cam.getLiveViewPixelWidth() > 0 ){
			img.allocate(cam.getLiveViewPixelWidth(), cam.getLiveViewPixelHeight(), OF_IMAGE_COLOR);
			//printf("allocating to %i %i \n", cam.getLiveViewPixelWidth(), cam.getLiveViewPixelHeight() );
		}else{
			//printf("image is set to %i %i \n", cam.getLiveViewPixelWidth(), cam.getLiveViewPixelHeight() );		
		}
		
		if( img.getWidth() > 0 && cam.getLiveViewPixelWidth() > 0  ){
			//printf("updating img\n");
			img.setFromPixels(cam.getLiveViewPixels(), cam.getLiveViewPixelWidth(), cam.getLiveViewPixelHeight(), OF_IMAGE_COLOR);
			bFrameNew = true;
		}
	}
}

//---------------------------------
void cameraCapture::draw(float x, float y, float w, float h){
	img.draw(x, y, w, h);
}

//---------------------------------
void cameraCapture::draw(float x, float y){
	img.draw(x, y);
}


